------------------------------------------------------------------------
-- Copyright Notice:                                                    
-- (c) Copyright 2004, National Optical Astronomy Observatory, which is 
-- operated for the National Science Foundation by the Association of   
-- Universities for Research in Astronomy under Cooperative Agreement   
-- No. AST-0132798.                                                     
--                                                                      
------------------------------------------------------------------------
-- PROJECT      :   MONSOON
-- BOARD        :   MASTER CONTROL BOARD
-- DEVICE ID    :   MCB PIXEL FPGA (U20)
-- PARENT MODULE:   TOP LEVEL  
-- MODULE       :   SYNC DATA BIT
-- VERSION      :   4.0 
------------------------------------------------------------------------
-- FILE NAME    :   EXDATALATCHV40.VHD
-- AUTHOR       :   PETER MOORE
-- DATE         :   04/18/2004
-- COMPANY      :   NOAO
-- PLATFORM     :   Xilinx ISE 5.2
------------------------------------------------------------------------
-- DESCRIPTION  :   
-- PROVIDES A PLACEHOLDER FOR FUTURE OPTIONS ON THIS PORT
------------------------------------------------------------------------
-- IMPLEMENTATION NOTES :
-- THERE IS CURRENTLY NO FUNCTIONAL REQUIREMENT FOR THIS PORT. HOWEVER,
-- IT IS THE ONLY METHOD OF A LINK BETWEEN SYNC'ED DHEs AND SO THERE
-- MUST BE A USE FOR IT SOMEDAY ;-)   
------------------------------------------------------------------------
-- REVISION HISTORY :
-- DATE        AUTHOR   VERSION  MODIFICATIONS
-- 04/18/2004   PCM    4.0  PLACEHOLDER FOR FUTURE FIRMWARE REQUIREMENTS. 
------------------------------------------------------------------------
-- PORT DEFINITIONS :


library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity ExDataLatchV40 is
  port (SYSCLK     : in    std_logic;
         EXDAT_CS  : in    std_logic;
         READ      : in    std_logic;
         DATA_IN   : in    std_logic;
         DATA_OUT  : inout std_logic_vector(15 downto 0);
         EXDAT_OUT : out   std_logic;
         EXDAT_IN  : in    std_logic
         );
end ExDataLatchV40;

architecture Behavioral of ExDataLatchV40 is

  signal ExDatReg : std_logic;

begin

------------------------------------------------------------------------
-- Ya' gotta catch the data value to set the the bits baby!
------------------------------------------------------------------------
  ExDatLatch : process(SYSCLK)
  begin
    if (rising_edge(SYSCLK)) then
      if (EXDAT_CS = '1' and READ = '0') then
        ExDatReg <= DATA_IN;
      end if;
    end if;
  end process;

  EXDAT_OUT <= ExDatReg;
  DATA_OUT  <= (x"000" & "00" & EXDAT_IN & ExDatReg) when (EXDAT_CS = '1' and READ = '1') else (others => 'Z');

end Behavioral;
