-------------------------------------------------------------------------------
-- Title      : Generic Ram module
-- Project    : 
-------------------------------------------------------------------------------
-- File       : genericRam.vhd
-- Author     :   <otger@PWOTGER>
-- Company    : 
-- Created    : 2008-12-15
-- Last update: 2008-12-15
-- Platform   : 
-- Standard   : VHDL'87
-------------------------------------------------------------------------------
-- Description: A basic, generic and multiplatform ram in vhdl. 
-------------------------------------------------------------------------------
-- Copyright (c) 2008 
-------------------------------------------------------------------------------
-- Revisions  :
-- Date        Version  Author  Description
-- 2008-12-15  1.0      otger	Created
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity genericRam is
  
  port (
    sysClk  : in  std_logic;
    address : in  std_logic_vector;
    wrData  : in  std_logic_vector;
    wr      : in  std_logic;
    rdData  : out std_logic_vector);

end genericRam;

architecture behavior of genericRam is

  type ramData is array (0 to (2**(address'length) - 1))
    of std_logic_vector(wrData'range);
  signal data : ramData;

begin  -- behavior

  main: process (sysClk)
  begin  -- process main
    if sysClk'event and sysClk = '1' then  -- rising clock edge
      if wr = '1' then
        data(to_integer(unsigned(address))) <= wrData;
      end if;
    end if;
  end process main;

  rdData <= data(to_integer(unsigned(address)));

end behavior;
