-------------------------------------------------------------------------------
-- Title      : Reset Sync
-- Project    : 
-------------------------------------------------------------------------------
-- File       : resetSync.vhd
-- Author     :   <otger@PWOTGER>
-- Company    : 
-- Created    : 2008-12-09
-- Last update: 2008-12-09
-- Platform   : 
-- Standard   : VHDL'87
-------------------------------------------------------------------------------
-- Description: When a reset is issued, a sync request with Pan is generated
-------------------------------------------------------------------------------
-- Copyright (c) 2008 
-------------------------------------------------------------------------------
-- Revisions  :
-- Date        Version  Author  Description
-- 2008-12-09  1.0      otger	Created
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;


entity resetSync is
  
  port (
    reset     : in  std_logic;
    sysClk    : in  std_logic;
    syncRcvd  : in  std_logic;
    asyncFlag : out std_logic);

end resetSync;

architecture ushee of resetSync is

begin  -- ushee

  main: process (sysClk, reset)
  begin  -- process main
    if reset = '1' then                 -- asynchronous reset (active high)
      asyncFlag <= '1';
    elsif sysClk'event and sysClk = '1' then  -- rising clock edge
      if syncRcvd = '1' then
        asyncFlag <= '0';
      end if;
    end if;
  end process main;

end ushee;
